---
title: Shader Editor
slug: Tools/Shader_Editor
---
<div>{{ToolsSidebar}}</div>

<div class="notecard note">
<p><strong>Note:</strong> This tool has been deprecated and will soon be removed from Firefox. For details, see <a href="/en-US/docs/Tools/Deprecated_tools">Deprecated tools</a>.</p>
</div>

<p>The Shader Editor enables you to see and edit the vertex and fragment shaders used by <a href="/en-US/docs/Web/WebGL">WebGL</a>.</p>

<p>{{EmbedYouTube("hnoKqFuJhu0")}}</p>

<p>WebGL is a <a href="/en-US/docs/Web/JavaScript">JavaScript</a> API for rendering interactive 3D graphics and 2D graphics in the browser without using plugins. With WebGL you provide 2 programs called <strong>shaders</strong> which are called at the appropriate stages of the <a href="https://www.opengl.org/wiki/Rendering_Pipeline_Overview">OpenGL rendering pipeline</a>: a <strong><a href="https://www.opengl.org/wiki/Vertex_Shader">vertex shader</a></strong>, which computes the clip space coordinates of each vertex to be drawn, and a <strong><a href="https://www.opengl.org/wiki/Fragment_Shader">fragment shader</a></strong>, which determines the color for each pixel to be drawn.<br>
 <br>
 These shaders are written in <strong>OpenGL Shading Language</strong>, or <strong><a href="https://www.opengl.org/documentation/glsl/">GLSL</a></strong>. In WebGL they can be included in a page in several ways: as text hardcoded in JavaScript strings, as separate files included using {{HTMLElement("script")}} tags, or retrieved from the server as plain text. JavaScript code running in the page then sends them for compilation using the WebGL APIs, and they're executed on the device's GPU when needed.</p>

<p>With the Shader Editor, you can examine and edit the source of the vertex and fragment shaders.</p>

<p>Here's another screencast, showing how you can use the Shader Editor for complex applications (in this case, the <a href="http://www.unrealengine.com/html5/">Unreal Engine</a> demo):</p>

<p>{{EmbedYouTube("YBErisxQkPQ")}}</p>

<h2 id="Opening_the_Shader_Editor">Opening the Shader Editor</h2>

<p>The Shader Editor is disabled by default. To enable it, open the <a href="/en-US/docs/Tools_Toolbox#Settings">Toolbox settings</a> and check "Shader Editor" in the "Default Firefox Developer Tools" item. You'll now see "Shader Editor" appear in the toolbar. Click it and the Shader Editor opens.<br>
 <br>
 At first you'll just see a blank window with a button asking you to reload the page:</p>

<p><img alt="" src="https://mdn.mozillademos.org/files/6421/shader-editor-open.png" style="display: block; margin-left: auto; margin-right: auto;"></p>

<p>To get started, load a page which creates a WebGL context and loads a program into it. The screenshots below are from the <a href="http://www.unrealengine.com/html5/">Unreal Engine</a> demo.</p>

<p>You'll now see a window divided into three panes: a list of all the GLSL programs on the left, the vertex shader for the currently selected program in the middle, and the fragment shader for the currently selected program on the right:</p>

<p><img alt="" src="https://mdn.mozillademos.org/files/6431/shader-editor-loaded.png" style="display: block; margin-left: auto; margin-right: auto;"></p>

<h2 id="Managing_programs">Managing programs</h2>

<p>The left hand pane lists all programs currently in use by a WebGL context. If you hover over an entry in the list, the geometry drawn by that program is highlighted in red:</p>

<p><img alt="" src="https://mdn.mozillademos.org/files/6427/shader-editor-highlight.png" style="display: block; margin-left: auto; margin-right: auto;">If you click the eyeball icon just left of the program's entry, that program is disabled. This is useful for focusing on certain shaders or hiding overlapping geometry:</p>

<p><img alt="" src="https://mdn.mozillademos.org/files/6429/shader-editor-disable.png" style="display: block; margin-left: auto; margin-right: auto;">If you click the entry, its vertex and fragment shaders are shown in the other two panes, and you can edit them.</p>

<h2 id="Editing_shaders">Editing shaders</h2>

<p>The middle and right hand panes show the vertex and fragment shaders for the currently selected program.<br>
 <br>
 You can edit these programs and see the results the next time the WebGL context redraws (for example, in the next animation frame). For example, you can modify the colors:</p>

<p><img alt="" src="https://mdn.mozillademos.org/files/6433/shader-editor-edit-color.png" style="display: block; margin-left: auto; margin-right: auto;">The editor highlights syntax errors in your code:</p>

<p><img alt="" src="https://mdn.mozillademos.org/files/6435/shader-editor-error.png" style="display: block; margin-left: auto; margin-right: auto;">If you hover over the cross shown next to a line containing an error, you'll see more details about the problem:</p>

<p><img alt="" src="https://mdn.mozillademos.org/files/6437/shader-editor-error-info.png" style="display: block; margin-left: auto; margin-right: auto;"></p>
